## tarantool 1.6.7.588.g76bbd9c

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(tarantool C CXX)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_INCLUDE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_INCLUDE_PATH})

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceRuns)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(TestBigEndian)
include(CheckFunctionExists)
include(FindOptionalPackage)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(JING jing)
find_program(LYNX lynx)
find_program(CAT cat)
find_program(GIT git)
find_program(LD ld)
find_program(CTAGS ctags)

# Define PACKAGE macro in tarantool/config.h
set (PACKAGE "Tarantool")

#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

# Define GNU standard installation directories
include(GNUInstallDirs)

include(cmake/utils.cmake)
include(cmake/pod2man.cmake)
# the order is significant: we need to know os and compiler to configure libs
include(cmake/arch.cmake)
include(cmake/os.cmake)
include(cmake/compiler.cmake)
include(cmake/simd.cmake)
include(cmake/atomic.cmake)
include(cmake/profile.cmake)
include(cmake/FindReadline.cmake)
include(cmake/FindSphinx.cmake)
include(cmake/systemd.cmake)
include(cmake/module.cmake)
include(cmake/thread.cmake)

if (NOT READLINE_FOUND)
    message(FATAL_ERROR "readline library not found.")
endif()

option(ENABLE_VALGRIND "Enable integration with valgrind, a memory analyzing tool" OFF)

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(unwind.h HAVE_UNWIND_H)
check_include_file(cpuid.h HAVE_CPUID_H)
check_include_file(sys/prctl.h HAVE_PRCTL_H)

check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
check_symbol_exists(fdatasync unistd.h HAVE_FDATASYNC)
check_symbol_exists(pthread_yield pthread.h HAVE_PTHREAD_YIELD)
check_symbol_exists(sched_yield sched.h HAVE_SCHED_YIELD)

check_function_exists(memmem HAVE_MEMMEM)
check_function_exists(memrchr HAVE_MEMRCHR)
check_function_exists(sendfile HAVE_SENDFILE)
if (HAVE_SENDFILE)
    if (TARGET_OS_LINUX)
        set(HAVE_SENDFILE_LINUX 1)
    else(HAVE_SENDFILE)
        set(HAVE_SENDFILE_BSD 1)
    endif()
endif()
check_function_exists(open_memstream HAVE_OPEN_MEMSTREAM)
check_function_exists(fmemopen HAVE_FMEMOPEN)
check_function_exists(funopen HAVE_FUNOPEN)
check_function_exists(fopencookie HAVE_FOPENCOOKIE)
check_function_exists(uuidgen HAVE_UUIDGEN)
#
# clock_gettime() is not defined on Mac OS X,
# or own (slow) implementation is in third_party/clock_gettime.c
#
if (TARGET_OS_LINUX)
    check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)
else()
    check_function_exists(clock_gettime HAVE_CLOCK_GETTIME)
endif()

# Checks for libev
include(CheckStructHasMember)
check_struct_has_member("struct stat" "st_mtim" "sys/stat.h"
    HAVE_STRUCT_STAT_ST_MTIM)
check_struct_has_member("struct stat" "st_mtimensec" "sys/stat.h"
    HAVE_STRUCT_STAT_ST_MTIMENSEC)

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

check_function_exists(setproctitle HAVE_SETPROCTITLE)
check_function_exists(setprogname HAVE_SETPROGNAME)
check_function_exists(getprogname HAVE_GETPROGNAME)

#
# Enable 'make tags' target.
#
add_custom_target(tags COMMAND ${CTAGS} -R -f tags
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(ctags DEPENDS tags)

#
# Define PACKAGE_VERSION -- a string constant with tarantool version.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "6")
set (CPACK_PACKAGE_VERSION_PATCH "7")

set (PACKAGE_VERSION "")

# Get git version only if source directory has .git repository, this
# avoids git to search .git repository in parent
# directories.
#
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
	execute_process (COMMAND ${GIT} describe HEAD
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Failed to retrive git version.")
    endif()
endif()

set (VERSION_FILE "${CMAKE_SOURCE_DIR}/VERSION")

# Update version file or use it when there is no git
# repository within sources (source tarballs).
#
if (PACKAGE_VERSION STREQUAL "")
    if (NOT EXISTS "${VERSION_FILE}")
        message (FATAL_ERROR "Version file ${VERSION_FILE} does not exists.")
    endif()
    message (WARNING "Using version from version file ${VERSION_FILE}")
	execute_process (COMMAND ${CAT} ${VERSION_FILE}
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Unable to retrive version from git or ${VERSION_FILE} file.")
    endif()
else()
	file(WRITE ${VERSION_FILE} "${PACKAGE_VERSION}\n")
endif()

#
# Specify where to look for include files.
#
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/small)
include_directories(${PROJECT_SOURCE_DIR})

#
# Specify Tarantool modules prefixes
#

set(MODULE_SUFFIX "tarantool")
set(MODULE_LIBDIR "${CMAKE_INSTALL_LIBDIR}/${MODULE_SUFFIX}")
set(MODULE_LUADIR "${CMAKE_INSTALL_DATADIR}/${MODULE_SUFFIX}")
set(MODULE_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/${MODULE_SUFFIX}")

foreach(dir
        LIBDIR
        LUADIR
        INCLUDEDIR
        )
    if(NOT IS_ABSOLUTE ${MODULE_${dir}})
        set(MODULE_FULL_${dir} "${CMAKE_INSTALL_PREFIX}/${MODULE_${dir}}")
    else()
        set(MODULE_FULL_${dir} "${MODULE_${dir}}")
    endif()
endforeach()

message(STATUS "Module sources:   ${MODULE_FULL_LUADIR}")
message(STATUS "Module libraries: ${MODULE_FULL_LIBDIR}")
message(STATUS "Module includes:  ${MODULE_FULL_INCLUDEDIR}")

list(APPEND MODULE_LUAPATH "${MODULE_FULL_LUADIR}/?.lua")
list(APPEND MODULE_LUAPATH "${MODULE_FULL_LUADIR}/?/init.lua")
list(APPEND MODULE_LIBPATH "${MODULE_FULL_LIBDIR}/?${CMAKE_SHARED_MODULE_SUFFIX}")

message(STATUS "Module package.path: ${MODULE_LUAPATH}")
message(STATUS "Module package.cpath: ${MODULE_LIBPATH}")

#
# Now handle all configuration options.
#
option(ENABLE_DOC "Enable building of documentation" OFF)

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC})
        # We only know this option to work with gcc
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
    # Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    check_library_exists (iberty cplus_demangle "" HAVE_IBERTY_LIB)
    set(CMAKE_REQUIRED_DEFINITIONS -DPACKAGE=${PACKAGE} -DPACKAGE_VERSION=${PACKAGE_VERSION})
    check_include_file(bfd.h HAVE_BFD_H)
    set(CMAKE_REQUIRED_DEFINITIONS)
    if (HAVE_BFD_LIB AND HAVE_BFD_H AND HAVE_IBERTY_LIB)
        set (HAVE_BFD True)
    endif()
endif()

##
## Third-Party libraries
##

#
# Since we *optionally* build bundled libs, a direct build
# dependency between tarantool_box and libluajit/libobjc won't
# work: add an empty custom target for this dependency instead.
# If a bundled objc or luajit is built, it is added to the
# dependency list of build_bundled_libs target.
#

add_custom_target(build_bundled_libs)

#
# LibLUAJIT
#
include(luajit)


#
# LibEV
#

#
# Currently our code uses libev with #define EV_MULTIPLICITY 0.
# This option means that libev has a global variable with
# struct ev_loop data.
# Such design is not compatible with the dynamic version of libev
# provided by distros.
set(ENABLE_BUNDLED_LIBEV ON)
include(BuildLibEV)
libev_build()
add_dependencies(build_bundled_libs ev)

#
# LibEIO
#
option(ENABLE_BUNDLED_LIBEIO "Enable building of the bundled libeio" ON)

if (ENABLE_BUNDLED_LIBEIO)
    include(BuildLibEIO)
    libeio_build()
    add_dependencies(build_bundled_libs eio)
else()
    set(LIBEIO_FIND_REQUIRED ON)
    find_package(LibEIO)
endif()


#
# LibCORO
#

#
# Tarantool uses 'coro' (coroutines) library to implement
# cooperative multi-tasking. Since coro.h is included
# universally, define the underlying implementation switch
# in the top level CMakeLists.txt, to ensure a consistent
# header file layout across the entire project.
#
set(ENABLE_BUNDLED_LIBCORO ON)
include(BuildLibCORO)
libcoro_build()
add_dependencies(build_bundled_libs coro)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "amd64")
    add_definitions("-DCORO_ASM")
elseif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    add_definitions("-DCORO_UCONTEXT")
else()
    add_definitions("-DCORO_SJLJ")
endif()


#
# LibGOPT
#

include(BuildLibGOPT)
libgopt_build()
add_dependencies(build_bundled_libs gopt)

#
# LibCJSON
#

include(BuildLibCJSON)
libcjson_build()
add_dependencies(build_bundled_libs cjson)

#
# LibYAML
#

option(ENABLE_BUNDLED_LIBYAML "Enable building of the bundled libyaml" ON)
if (ENABLE_BUNDLED_LIBYAML)
    include(BuildLibYAML)
    libyaml_build()
    add_dependencies(build_bundled_libs yaml)
else()
    set(LIBYAML_FIND_REQUIRED ON)
    find_package(LibYAML)
endif()

#
# Third-Party misc
#

include(BuildMisc)
libmisc_build()
add_dependencies(build_bundled_libs misc)

include(BuildSophia)
sophia_build()

option(ENABLE_RPM "Enable install of a RPM specific files" OFF)

# cpack config. called package.cmake to avoid
# conflicts with the global CPack.cmake (On MacOS X
# file names are case-insensitive)
#
include (cmake/package.cmake)
#
# RPM build environment
# CPACK is only used for .tar.gz package generation.
# To build an RPM we need a source package,
# so rpm.cmake depends on package.cmake.
#
include (cmake/rpm.cmake)

add_subdirectory(src)
add_subdirectory(extra)
add_subdirectory(test)
add_subdirectory(doc)

install (FILES README.md LICENSE
         DESTINATION share/doc/tarantool)

#
# tarantool info summary (used in server version output)
#
set(TARANTOOL_OPTIONS "-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_TRACE=${ENABLE_TRACE} -DENABLE_BACKTRACE=${ENABLE_BACKTRACE}")
set(TARANTOOL_BUILD "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_BUILD_TYPE}")
set(TARANTOOL_C_COMPILER ${CMAKE_C_COMPILER})
set(TARANTOOL_CXX_COMPILER ${CMAKE_CXX_COMPILER})

#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/src/trivia/config.h.cmake"
    "${PROJECT_BINARY_DIR}/src/trivia/config.h"
    )
message (STATUS "")
message (STATUS "Tarantool configuration is complete:")
message (STATUS "")
message (STATUS "VERSION: ${PACKAGE_VERSION}")
message (STATUS "BUILD: ${TARANTOOL_BUILD}")
message (STATUS "C_COMPILER: ${TARANTOOL_C_COMPILER}")
message (STATUS "CXX_COMPILER: ${TARANTOOL_CXX_COMPILER}")

=== doc/CMakeLists.txt ===
add_subdirectory(man)

if (ENABLE_DOC)
    configure_file(
        "${PROJECT_SOURCE_DIR}/doc/www/content/newsite/download.yml.in"
        "${PROJECT_BINARY_DIR}/doc/www/content/newsite/download.yml"
        )

    add_subdirectory(sphinx)
    add_subdirectory(www)
endif()

=== doc/requirements.txt ===
pygments>=2.0.0
pelican>=3.5.0
BeautifulSoup>=3.2.0
breathe>=4.0.0

=== extra/CMakeLists.txt ===
add_subdirectory(dist)

configure_file(rpm/tarantool.rpm.spec.in rpm/tarantool.rpm.spec @ONLY)

if (TARGET_OS_DARWIN)
	# NOTE: need add execution 'plutil -lint org.tarantool.tarantool.plist
	# to check syntax of plist file.
	# Also cmake doesn't support changing package id from 'com.' to 'org.'
	# Need chage to 'org.' after update lines this file:
	# https://github.com/Kitware/CMake/blob/v2.8.11.2/Source/CPack/cmCPackPackageMakerGenerator.cxx#L763
	#
	# ^^^ DO NOT CHANGE DARWIN_PACKAGE_ID BEFORE SEE URL ABOVE ^^^
	#
	set (DARWIN_PACKAGE_ID "com")
	set (LUANCHD_PLIST "${DARWIN_PACKAGE_ID}.${CPACK_PACKAGE_VENDOR}.tarantool.plist")
	# Configure scripts for *.pkg and luanchd daemon by templates
	configure_file(dmg/postflight.in postflight @ONLY)
	configure_file(org.tarantool.in ${LUANCHD_PLIST} @ONLY)
	# chmod +x 644
	install (FILES ${CMAKE_BINARY_DIR}/extra/${LUANCHD_PLIST}
                 DESTINATION share/tarantool
         PERMISSIONS
         OWNER_READ OWNER_WRITE
         GROUP_READ GROUP_READ
         WORLD_READ WORLD_READ)
endif()

add_executable(txt2c txt2c.c)
add_executable(bin2c bin2c.c)

=== src/CMakeLists.txt ===
#
# Set compile flags for entire src/ directory
#
enable_tnt_compile_flags()

include_directories(${LIBEV_INCLUDE_DIR})
include_directories(${LIBEIO_INCLUDE_DIR})
include_directories(${LIBCORO_INCLUDE_DIR})
include_directories(${LIBGOPT_INCLUDE_DIR})
include_directories(${READLINE_INCLUDE_DIR})

set(LIBUTIL_FREEBSD_SRC ${CMAKE_SOURCE_DIR}/third_party/libutil_freebsd)
include_directories(${LIBUTIL_FREEBSD_SRC})

# Compile src/lua/*.lua files into src/lua/*.lua.c sources
set(lua_sources)
lua_source(lua_sources lua/init.lua)
lua_source(lua_sources lua/fiber.lua)
lua_source(lua_sources lua/buffer.lua)
lua_source(lua_sources lua/uuid.lua)
lua_source(lua_sources lua/digest.lua)
lua_source(lua_sources lua/msgpackffi.lua)
lua_source(lua_sources lua/uri.lua)
lua_source(lua_sources lua/console.lua)
lua_source(lua_sources lua/socket.lua)
lua_source(lua_sources lua/errno.lua)
lua_source(lua_sources lua/log.lua)
lua_source(lua_sources lua/help.lua)
lua_source(lua_sources lua/help_en_US.lua)
lua_source(lua_sources lua/tap.lua)
lua_source(lua_sources lua/fio.lua)
lua_source(lua_sources lua/csv.lua)
lua_source(lua_sources lua/strict.lua)
lua_source(lua_sources lua/clock.lua)
lua_source(lua_sources lua/title.lua)
lua_source(lua_sources ../third_party/luafun/fun.lua)
# LuaJIT jit.* library
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/bc.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/bcsave.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/dis_x86.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/dis_x64.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/dump.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/vmdef.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/v.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/p.lua")
lua_source(lua_sources "${CMAKE_BINARY_DIR}/third_party/luajit/src/jit/zone.lua")

add_custom_target(generate_lua_sources
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

add_custom_target(ragel
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMAND ragel -G2 src/uri.rl -o src/uri.c)

set (core_sources
     diag.c
     say.c
     memory.c
     fiber.c
     cbus.c
     exception.cc
     coro.c
     reflection.c
     assoc.c
     rmean.c
     util.c
 )

add_library(core STATIC ${core_sources})
target_link_libraries(core
    salad small pthread
    ${LIBEV_LIBRARIES}
    ${LIBCORO_LIBRARIES}
)

set (server_sources
     find_path.c
     sio.cc
     evio.cc
     coio.cc
     coeio.cc
     iobuf.cc
     coio_buf.cc
     pickle.c
     ipc.c
     latch.cc
     errinj.cc
     fio.c
     crc32.c
     random.c
     scramble.c
     opts.c
     cfg.c
     cpu_feature.c
     fiob.c
     tt_uuid.c
     uri.c
     backtrace.cc
     proc_title.c
     coeio_file.cc
     lua/digest.cc
     lua/init.cc
     lua/fiber.cc
     lua/trigger.cc
     lua/ipc.cc
     lua/msgpack.cc
     lua/utils.cc
     lua/errno.c
     lua/socket.cc
     lua/pickle.cc
     lua/fio.cc
     lua/clock.c
     ${lua_sources}
     ${PROJECT_SOURCE_DIR}/third_party/lua-yaml/lyaml.cc
     ${PROJECT_SOURCE_DIR}/third_party/lua-yaml/b64.c
)

set(api_headers
    ${CMAKE_BINARY_DIR}/src/trivia/config.h
    ${CMAKE_SOURCE_DIR}/src/say.h
    ${CMAKE_SOURCE_DIR}/src/fiber.h
    ${CMAKE_SOURCE_DIR}/src/coio.h
    ${CMAKE_SOURCE_DIR}/src/coeio.h
    ${CMAKE_SOURCE_DIR}/src/lua/utils.h
    ${CMAKE_SOURCE_DIR}/src/box/txn.h
    ${CMAKE_SOURCE_DIR}/src/box/tuple.h
    ${CMAKE_SOURCE_DIR}/src/box/schema.h
    ${CMAKE_SOURCE_DIR}/src/box/box.h
    ${CMAKE_SOURCE_DIR}/src/box/index.h
    ${CMAKE_SOURCE_DIR}/src/box/func.h
    ${CMAKE_SOURCE_DIR}/src/box/error.h
    ${CMAKE_SOURCE_DIR}/src/box/lua/call.h
    ${CMAKE_SOURCE_DIR}/src/latch.h
)
rebuild_module_api(${api_headers})

if (NOT TARGET_OS_DEBIAN_FREEBSD)
    if (TARGET_OS_FREEBSD)
        set_source_files_properties(
        ${PROJECT_SOURCE_DIR}/src/proc_title.c
        PROPERTIES COMPILE_FLAGS "-DHAVE_SETPROCTITLE")
    endif()
endif()

if (ENABLE_TRACE)
    set (server_sources ${server_sources} trace.c)
endif()

set_source_files_compile_flags(${server_sources})
add_library(server STATIC ${server_sources})
target_link_libraries(server core bit)

set (common_libraries server core misc bitset msgpuck csv)

list(APPEND common_libraries
    ${LIBEIO_LIBRARIES}
    ${LIBGOPT_LIBRARIES}
    ${LIBCJSON_LIBRARIES}
    ${LIBYAML_LIBRARIES}
    ${READLINE_LIBRARIES}
    ${LUAJIT_LIB}
)

if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    set (common_libraries ${common_libraries} dl rt)
endif()

if (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
    find_library (INTL intl)
    if (NOT INTL)
        message(FATAL_ERROR "intl library not found")
    else()
        set (common_libraries ${common_libraries} ${INTL})
    endif()
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
    find_package (ZLIB)
    set (common_libraries ${common_libraries} bfd ${ZLIB_LIBRARIES})
    if (NOT TARGET_OS_DARWIN)
        set (common_libraries ${common_libraries} iberty)
    endif()
    if (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
        set (common_libraries ${common_libraries} iconv)
    endif()
endif()

set (common_libraries ${common_libraries} ${LIBUUID_LIBRARIES})
set (common_libraries ${common_libraries} PARENT_SCOPE)

add_subdirectory(lib)
add_subdirectory(box)

# Save CMAKE_XXX_FLAGS from this directory for config.h (used in --version)
set(TARANTOOL_C_FLAGS ${CMAKE_C_FLAGS} PARENT_SCOPE)
set(TARANTOOL_CXX_FLAGS ${CMAKE_CXX_FLAGS} PARENT_SCOPE)

add_executable(
	tarantool main.cc ffisyms.cc title.c
	${LIBUTIL_FREEBSD_SRC}/flopen.c
	${LIBUTIL_FREEBSD_SRC}/pidfile.c)
add_dependencies(tarantool build_bundled_libs)
target_link_libraries(tarantool box ${common_libraries})

if (TARGET_OS_DARWIN)
    # Necessary to make LuaJIT work on Darwin, see
    # http://luajit.org/install.html
    set_target_properties(tarantool PROPERTIES
        LINK_FLAGS "-pagezero_size 10000 -image_base 100000000")
elseif (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
    # Helps symbol resolution of plug-ins
    set_target_properties(tarantool PROPERTIES LINK_FLAGS "-rdynamic")
endif()
install (TARGETS tarantool DESTINATION bin)

=== test-run/requirements.txt ===
python-daemon>=1.5.5
PyYAML==3.10
argparse==1.1
msgpack-python==0.4.6
gevent==1.1b5
six>=1.8.0

=== test/CMakeLists.txt ===
enable_tnt_compile_flags()

function(build_module module files)
    add_library(${module} SHARED ${files})
    set_target_properties(${module} PROPERTIES PREFIX "")
    add_dependencies(${module} api)
    if(TARGET_OS_DARWIN)
        set_target_properties(${module} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif(TARGET_OS_DARWIN)
endfunction()


add_compile_flags("C;CXX"
    "-Wno-unused-parameter")

if(POLICY CMP0037)
    cmake_policy(SET CMP0037 OLD)
endif(POLICY CMP0037)

add_custom_target(test
    COMMAND ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --vardir=${PROJECT_BINARY_DIR}/test/var)

add_custom_target(test-force
    COMMAND ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --force --vardir=${PROJECT_BINARY_DIR}/test/var)

add_subdirectory(app)
add_subdirectory(box)
add_subdirectory(unit)

# Move tarantoolctl config
if (NOT ${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    configure_file(
        "${PROJECT_SOURCE_DIR}/test/.tarantoolctl"
        "${PROJECT_BINARY_DIR}/test/.tarantoolctl"
        )
endif()

# Disable connector_c for 1.6
#add_subdirectory(connector_c)

=== doc/man/CMakeLists.txt ===
pod2man (
    tarantool.pod "tarantool" 1
    "Lua application server and NoSQL database"
)

=== extra/dist/CMakeLists.txt ===
# Scripts for a tarantoolctl packaging
set(SYSV_INITD_PATH ${CMAKE_INSTALL_LIBDIR}/tarantool/tarantool.init)
# Default path to data in default/tarantool
if (NOT TARANTOOL_DATADIR)
    set(TARANTOOL_DATADIR "/var/lib/tarantool")
endif()
message (STATUS "TARANTOOL_DATADIR: ${TARANTOOL_DATADIR}")

configure_file("tarantool.service.in" "tarantool.service")
configure_file(default/tarantool.in default/tarantool)

if (ENABLE_RPM)
    # chmod +x 655
    if (WITH_SYSTEMD)
    message (STATUS "Building RPM with SYSTEMD")
        install (FILES ${PROJECT_BINARY_DIR}/extra/dist/tarantool.service DESTINATION ${SYSTEMD_SERVICES_INSTALL_DIR}
            PERMISSIONS
            OWNER_READ OWNER_WRITE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
        install (FILES tarantool.init DESTINATION ${CMAKE_INSTALL_LIBDIR}/tarantool/
            PERMISSIONS
            OWNER_READ OWNER_WRITE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
    else (WITH_SYSTEMD)
    message (STATUS "Building RPM without SYSTEMD")
        install (FILES tarantool.init DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/init.d/
            RENAME tarantool
            PERMISSIONS
            OWNER_READ OWNER_WRITE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
    endif(WITH_SYSTEMD)
    install (FILES ${PROJECT_BINARY_DIR}/extra/dist/default/tarantool DESTINATION
        ${CMAKE_INSTALL_SYSCONFDIR}/sysconfig/
    PERMISSIONS
    OWNER_READ OWNER_WRITE
    GROUP_READ
    WORLD_READ)
else (ENABLE_RPM)
    install (FILES ${PROJECT_BINARY_DIR}/extra/dist/default/tarantool DESTINATION
        ${CMAKE_INSTALL_SYSCONFDIR}/default/
    PERMISSIONS
    OWNER_READ OWNER_WRITE
    GROUP_READ
    WORLD_READ)
endif(ENABLE_RPM)

install (FILES tarantoolctl DESTINATION ${CMAKE_INSTALL_BINDIR}
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
)

install (FILES example.lua DESTINATION
        ${CMAKE_INSTALL_SYSCONFDIR}/tarantool/instances.available
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_READ
    GROUP_READ GROUP_READ
    WORLD_READ WORLD_READ
)

pod2man (
    tarantoolctl "tarantoolctl" 1
    "tarantoolctl instances control"
)

=== src/box/CMakeLists.txt ===
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/box/lua)

include_directories(${SOPHIA_INCLUDE_DIR})

set(lua_sources)
lua_source(lua_sources lua/load_cfg.lua)
lua_source(lua_sources lua/schema.lua)
lua_source(lua_sources lua/tuple.lua)
lua_source(lua_sources lua/session.lua)
lua_source(lua_sources lua/snapshot_daemon.lua)
lua_source(lua_sources lua/net_box.lua)
set(bin_sources)
bin_source(bin_sources bootstrap.snap bootstrap.h)

add_custom_target(box_generate_lua_sources
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

add_library(box
    iproto.cc
    iproto_constants.c
    iproto_port.cc
    errcode.c
    error.cc
    xrow.cc
    xlog.cc
    tuple.cc
    tuple_convert.cc
    tuple_update.cc
    key_def.cc
    index.cc
    memtx_index.cc
    memtx_hash.cc
    memtx_tree.cc
    memtx_rtree.cc
    memtx_bitset.cc
    engine.cc
    memtx_engine.cc
    sysview_engine.cc
    sysview_index.cc
    sophia_engine.cc
    sophia_index.cc
    space.cc
    func.cc
    alter.cc
    schema.cc
    session.cc
    port.cc
    request.cc
    txn.cc
    box.cc
    user_def.cc
    user.cc
    authentication.cc
    vclock.c
    cluster.cc
    recovery.cc
    applier.cc
    relay.cc
    wal.cc
    ${lua_sources}
    lua/call.cc
    lua/tuple.cc
    lua/slab.cc
    lua/index.cc
    lua/space.cc
    lua/info.cc
    lua/stat.cc
    lua/sophia.cc
    lua/error.cc
    lua/session.cc
    lua/net_box.cc
    ${bin_sources})

target_link_libraries(box ${sophia_lib})

=== src/lib/CMakeLists.txt ===
add_subdirectory(bit)
add_subdirectory(bitset)
set(SMALL_EMBEDDED ON)
add_subdirectory(small)
add_subdirectory(salad)
add_subdirectory(csv)
add_library(msgpuck STATIC msgpuck/msgpuck.c)

=== test/box/CMakeLists.txt ===
build_module(function1 function1.c)

=== debian/changelog ===
tarantool (1.6.7.588.g76bbd9c-1build1) xenial; urgency=medium

  * No-change rebuild for binutils 2.26.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Jan 2016 16:44:07 +0000

tarantool (1.6.7.588.g76bbd9c-1) unstable; urgency=medium

  * Fix `libiberty | bintuils-dev, binutils-dev` B-D
  * Convert tarantool-common to architecture-independent package.
  * Disable kfreebsd - produced binaries have always been broken and
    the upstream is unable to fix it.
  * Use Maintainer and Uploaders fields properly

 -- Roman Tsisyk <roman@tarantool.org>  Sat, 16 Jan 2016 11:26:52 +0300

tarantool (1.6.7.551.ga5bafc5-1) unstable; urgency=medium

  * Add zlib1g-dev to B-D (FTBFS), closes: #808516.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 21 Dec 2015 12:46:41 +0300

tarantool (1.6.7.541.g89c4578-1) unstable; urgency=medium

  * New Debian snapshot for 1.6.7 stable release.
   - New tarantool doesn't have 8K tuples problem, closes: #704720.
   - New tarantool is built without Lua, closes: #655801.

  Major changes:

   - threaded architecture for checkpointing. Tarantool no longer
     forks to create a snapshot, but uses a separate thread,
     accessing data via a consistent read view. This eliminates all known
     latency spikes caused by snapshotting.
   - threaded architecture for network. Network I/O has finally
     been moved to a separate thread, increasing single instance
     performance by up to 50%.
   - stored procedures in C/C++. Stored procedures in C/C++
     provide speed (3-4 times, compared to a Lua version in
     our measurements), as well as unlimited extensibility
     power.
   - new HASH index implementation which respects slab_alloc_arena
     limit and uses significantly less memory.
   - RTREE index support (Memtx engine).
   - new 'upsert' command available in the binary protocol
     and in stored functions.
   - multi-master replication with support up to 30 peers.
   - logger option now accepts a syntax for syslog output. Use uri-style
     syntax for file, pipe or syslog log destination.
   - new version of sophia engine, with support of compression and multipart
     primary keys.
   - jit.*, jit.dump, jit.util, jit.vmdef modules of LuaJIT 2.0 are now
     available as built-ins.
   - better documentation and examples.
   - manifold performance improvements.
   - bug fixes.

  Incompatible changes:

   - fiber.channel.broadcast() was removed since it wasn't used by
     anyone and didn't work properly.
   - tarantoolctl "reload" command renamed to "eval".
   - panic_on_wal_error is on by default (gh-752)
   - functions which create objects (users, spaces, or functions)
     return an error if an object already exists. Use
     {if_not_exists=true} clause in create functions.
   - an update of the primary key was forbidden; use replace instead.

   Package changes:

   - Actualize debian/copyright
   - Remove support for GNU hurd architecture (doesn't work).
   - Don't use /var/lib/tarantool/started and /var/lib/tarantool/snapshot dirs.
   - Drop irrelevant README.Debian.
   - Remove old cron scripts.

 -- Roman Tsisyk <roman@tarantool.org>  Mon, 14 Dec 2015 20:00:00 +0300

tarantool (1.6.5.20.g51b2e0d-1) unstable; urgency=medium

  * Remove tarantool-mysql-module, tarantool-pg-module and tarantool-modules.

 -- Roman Tsisyk <roman@tarantool.org>  Tue, 28 Apr 2015 14:34:17 +0300

=== debian/control ===
Source: tarantool
Priority: optional
Maintainer: Roman Tsisyk <roman@tarantool.org>
Uploaders: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 cmake,
 libreadline-dev,
 libncurses5-dev,
 libyaml-dev,
# Dependecies below are needed for fiber stack traces
# libiberty.so is provided by binutils-dev (<< 2.24) for wheezy and precise
 libiberty-dev | binutils-dev (<< 2.24),
# libbfd-*.so
 binutils-dev,
# zlib is implicitly needed by libbfd #808516
 zlib1g-dev
Section: database
Standards-Version: 3.9.6
Homepage: http://tarantool.org/
VCS-Browser: https://github.com/tarantool/tarantool
VCS-Git: git://github.com/tarantool/tarantool.git

Package: tarantool-common
Architecture: all
Priority: optional
Conflicts: tarantool-common (<< 1.5.3),
 tarantool-lts-common,
 tarantool-lts,
 tarantool-lts-modules,
 tarantool-lts-client,
 tarantool-lts-postgresql-module,
 tarantool-lts-mysql-module,
 tarantool-lts-dev,
 tarantool-dbg (<< 1.5.2),
 tarantool-common (<< 1.6~),
 tarantool-client (<< 1.6~),
 tarantool-client-dbg (<< 1.6~),
 tarantool-plugins (<< 1.6~),
 tarantool-mysql-plugin (<< 1.6~),
 tarantool-postgresql-plugin (<< 1.6~),
 tarantool-modules,
 tarantool-mysql-module,
 tarantool-postgresql-module,
 libtarantool-dev (<< 1.6~)
Replaces: tarantool-common (<< 1.5.3), tarantool-lts-common
Depends: ${misc:Depends}, adduser, lsb-base
Description: Tarantool in-memory database - common files
 Tarantool is an in-memory database and Lua application server.
 This package provides scripts to work with tarantool configuration
 and log files.

Package: tarantool
Architecture: i386 amd64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils, libgomp1, libyaml-0-2
Replaces: tarantool-lts
Conflicts: tarantool-lts-common,
 tarantool-lts,
 tarantool-lts-modules,
 tarantool-lts-postgresql-module,
 tarantool-lts-mysql-module,
 tarantool-lts-dev,
 tarantool-lts-client,
 tarantool-dbg (<< 1.5.2),
 tarantool-common (<< 1.6~),
 tarantool-client (<< 1.6~),
 tarantool-client-dbg (<< 1.6~),
 tarantool-plugins (<< 1.6~),
 tarantool-mysql-plugin (<< 1.6~),
 tarantool-postgresql-plugin (<< 1.6~),
 libtarantool-dev (<< 1.6~),
 tarantool-modules (<< 1.6.7),
 tarantool-mysql-module (<< 1.6.7),
 tarantool-postgresql-module (<< 1.6.7)
Recommends: tarantool-common (>= 1.6)
Description: In-memory database with a Lua application server
 Tarantool is an in-memory database and a Lua application server.
 Its key properties include:
 .
  * flexible data model
  * multiple index types: HASH, TREE, BITSET
  * optional persistence and strong data durability
  * log streaming replication
  * Lua functions, procedures, triggers, with rich access to database API,
    JSON support, inter-procedure and network communication libraries
 .
 This package provides Tarantool command line interpreter and server.

Package: tarantool-dev
Architecture: i386 amd64
Priority: optional
Section: libdevel
Replaces: tarantool-lts-dev
Conflicts: tarantool-lts-common,
 tarantool-lts,
 tarantool-lts-modules,
 tarantool-lts-postgresql-module,
 tarantool-lts-mysql-module,
 tarantool-lts-client,
 tarantool-lts-dev,
 tarantool-dbg (<< 1.5.2),
 tarantool-common (<< 1.6~),
 tarantool-client (<< 1.6~),
 tarantool-client-dbg (<< 1.6~),
 tarantool-plugins (<< 1.6~),
 tarantool-mysql-plugin (<< 1.6~),
 tarantool-postgresql-plugin (<< 1.6~),
 libtarantool-dev (<< 1.6~)
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool (= ${binary:Version})
Description: Tarantool in-memory database - development headers
 Tarantool is an in-memory database and Lua application server.
 This package provides server development files needed to build pluggable
 modules.

=== debian/rules ===
#!/usr/bin/make -f


VERSION  := $(shell dpkg-parsechangelog|grep ^Version|awk '{print $$2}')
UVERSION := $(shell echo $(VERSION)|sed 's/-[[:digit:]]\+$$//')

DEB_CMAKE_EXTRA_FLAGS := \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

DEB_DH_INSTALLINIT_ARGS := --name=tarantool

DEB_CMAKE_INSTALL_PREFIX := /usr
DEB_CMAKE_NORMAL_ARGS := -DCMAKE_INSTALL_PREFIX="$(DEB_CMAKE_INSTALL_PREFIX)" \
	-DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_INSTALL_SYSCONFDIR=/etc \
	-DCMAKE_INSTALL_LOCALSTATEDIR=/var \
	-DCMAKE_INSTALL_LIBDIR=/usr/lib \
	-DENABLE_BUNDLED_LIBYAML=OFF
#     -DCMAKE_C_FLAGS="$(CFLAGS)" \
#     -DCMAKE_LD_FLAGS="$(LDFLAGS)" \
#     -DENABLE_STATIC=ON
#     -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
#     -DCMAKE_CPP_FLAGS="$(CPPFLAGS)" \
#    -DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
#    -DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \

DEB_INSTALL_DOCS_ALL 		:= -XTODO -XAUTHORS
# Needed for proper backtraces in fiber.info()
DEB_DH_STRIP_ARGS	        := -X/usr/bin/tarantool
export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector,-pie
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_BUILDDIR := build-area

tarball: clean
	git describe --long --always > VERSION
	tar --exclude=.git --exclude=debian 		\
		--exclude=doc/www					\
		--exclude=doc/sphinx				\
		--exclude=src/lib/small/debian		\
		--exclude=src/lib/msgpuck/debian    \
		--exclude=test-run/lib/tarantool-python/debian \
		--exclude=third_party/sophia/debian \
		--exclude=third_party/luafun/debian \
		--exclude=FreeBSD \
		--transform='s,^\.,tarantool_$(UVERSION),S' \
		-czf ../tarantool_$(UVERSION).orig.tar.gz .

clean::
	find -type f -name \*.pyc -delete
	find -type d -name CMakeFiles -exec rm -fr '{}' +
	rm -f CMakeCache.txt
	rm -f CPackConfig.cmake
	rm -f CPackSourceConfig.cmake
	rm -f src/trivia/config.h

install/tarantool::

=== debian/watch ===
version=3
	https://github.com/tarantool/tarantool/tags \
		.*/tarball/(\d+(?:\.\d+)+)
